/** googlenewswin.cpp
 * Googleニュース検索
 *
 * @copyright	(c)studio pahoo
 * @author		パパぱふぅ
 * @動作環境	MinGW C++ + cURL + OpenSSL + Boost C++ Libraries
 * @参考URL		https://www.pahoo.org/e-soul/webtech/cpp01/cpp01-08-01.shtm
 *
*/
// 初期化処理 ==============================================================
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include <time.h>
#include <sstream>
#include <string>
#include <winsock2.h>
#include <windows.h>
#include <shlobj.h>
#include <commctrl.h>
#include <richedit.h>
#include <curl/curl.h>
#include <boost/property_tree/xml_parser.hpp>
#include <boost/format.hpp>
#include "resource.h"

using namespace std;
using namespace boost;
using namespace boost::property_tree;

#define MAKER		"pahoo.org"				// 作成者
#define APPNAME		"googlenewswin"			// アプリケーション名
#define APPNAMEJP	"Googleニュース検索"	// アプリケーション名（日本語）
#define APPVERSION	"1.5.10"				// バージョン
#define APPYEAR		"2020-2026"				// 作成年
#define REFERENCE	"https://www.pahoo.org/e-soul/webtech/cpp01/cpp01-08-01.shtm"	// 参考サイト

// char*バッファサイズ
#define SIZE_BUFF		5120

// ListViewItemの最大文字長：変更不可
#define MAX_LISTVIEWITEM	259

// 標準フォント
#define FONT_FACE		"MS UI Gothic"

// Googleニュース検索URL
#define URL_GOOGLENEWS	"https://news.google.com/rss/search?hl=ja&gl=JP&ceid=JP:ja&q="

// 現在のインターフェイス
static HINSTANCE hInst;

// アプリケーション・ウィンドウ
HWND hParent;

// アプリケーション・ウィンドウ位置
unsigned hParent_X, hParent_Y;

// エラー・メッセージ格納用
string ErrorMessage;

// 検索キー格納用
string Query;

// ヘルプ・ファイル
#define HELPFILE	".\\etc\\help.chm"

// デフォルト保存ファイル名
#define SAVEFILE	"googlenewswin.csv"

// UserAgent
string UserAgent;

// ニュース格納用クラス
#define SIZE_NEWS	500		// 格納ニュース数
class _News {
public:
	wstring title = L"";		// 見出し
	string link = "";			// 記事リンク
	string pubdate = "";		// 配信日時
	time_t ti = 0;				// 配信日時（time_t型）
	wstring description = L"";	// 記事概要
	wstring source = L"";		// メディア
};
unique_ptr<_News> News[SIZE_NEWS] = {};

// ソート用構造体
struct _stNews {
	wchar_t* title;				// 見出し
	char* pubdate;				// 配信日時
	time_t ti;					// 配信日時（time_t型）
	char* link;					// 記事リンク
	wchar_t* source;			// メディア
};
vector<_stNews> Vnews;

// バージョン情報
string Version = (boost::format(R"(
%1%  バージョン %2%

本アプリケーションはMIT Licenseです．
商用を含む無償利用が可能です．自由に改造できます．
再配布の際は，下記の著作権表記，およびURLと本使用条件を必ず明記してください．

　Copyright by (c)studio pahoo, %3%
　https://www.pahoo.org/

なお，本アプリケーションの利用または改造することによって生じた得失ついては一切関知いたしません．APIの変更・停止によって正常に機能しなくなる場合があります．また，二次利用先の組織・企業・団体の目的・内容・活動については一切関知いたしません．

本アプリケーションは，下記のライブラリ，フレームワーク，APIを利用しています．
　MinGW(g++), Boost C++ライブラリ, cURL, OpenSSL，Googleニュース
)")
% APPNAMEJP
% APPVERSION
% APPYEAR
).str();

// サブ・プログラム =====================================================
typedef void (WINAPI *RtlGetVersion_FUNC)(OSVERSIONINFOEXW*);

/**
 * Windowsバージョン取得
 * @param	OSVERSIONINFOEX* os バージョン情報を格納
 * @return	bool TRUE/FALSEなし
 */
BOOL GetVersion2(OSVERSIONINFOEX* os) {
	HMODULE hMod;
	RtlGetVersion_FUNC func;
#ifdef UNICODE
	OSVERSIONINFOEXW* osw = os;
#else
	OSVERSIONINFOEXW o;
	OSVERSIONINFOEXW* osw = &o;
#endif

	hMod = LoadLibrary(TEXT("ntdll.dll"));
	if (hMod) {
		func = (RtlGetVersion_FUNC)GetProcAddress(hMod, "RtlGetVersion");
		if (func == 0) {
			FreeLibrary(hMod);
			return FALSE;
		}
		ZeroMemory(osw, sizeof(*osw));
		osw->dwOSVersionInfoSize = sizeof(*osw);
		func(osw);
#ifndef UNICODE
		os->dwBuildNumber = osw->dwBuildNumber;
		os->dwMajorVersion = osw->dwMajorVersion;
		os->dwMinorVersion = osw->dwMinorVersion;
		os->dwPlatformId = osw->dwPlatformId;
		os->dwOSVersionInfoSize = sizeof(*os);
//		DWORD sz = sizeof(os->szCSDVersion);
		WCHAR* src = osw->szCSDVersion;
		unsigned char* dtc = (unsigned char*)os->szCSDVersion;
		while (*src) {
			*dtc++ = (unsigned char)*src++;
		}
		*dtc = '\0';
#endif

	} else {
		return FALSE;
	}
	FreeLibrary(hMod);

return TRUE;
}

// クリップボード関連 ======================================================
/**
 * クリップボードに文字列をセット
 * @param	string str 文字列
 * @return	なし
*/
void setClipboardData(string str) {
	char buff[str.size() + 1];
	char_traits<char>::copy(buff, str.c_str(), str.size() + 1);

	OpenClipboard(NULL);
	EmptyClipboard();

	HGLOBAL hText = GlobalAlloc(GHND | GMEM_SHARE, SIZE_BUFF);
	PTSTR pText = (PTSTR)GlobalLock(hText);
	lstrcpy(pText, buff);
	GlobalUnlock(hText);
	SetClipboardData(CF_TEXT, hText);
	CloseClipboard();
}

/**
 * クリップボードから文字列を取得
 * @param	なし
 * @return	文字列／NULL＝取得失敗
*/
char* getClipboardData(void) {
	static char buff[SIZE_BUFF + 1];

	OpenClipboard(NULL);
	HGLOBAL hText = GetClipboardData(CF_TEXT);

	if (hText == NULL) {
		return NULL;
	} else {
		PTSTR pText = (PTSTR)GlobalLock(hText);
		lstrcpy(buff, pText);
		GlobalUnlock(hText);
	}
	CloseClipboard();

	return buff;
}

// GUI処理 =================================================================
/**
 * テキストボックスに文字列を代入
 * @param  HWND		hDlg  ダイアログID
 * @param  unsigned	id    テキストボックスID
 * @param  string	s     設定値
 * @return なし
*/
void setStrEditBox(HWND hDlg, unsigned id, string s) {
	char buff[SIZE_BUFF + 1];
	char_traits<char>::copy(buff, s.c_str(), s.size() + 1);
	SetDlgItemText(hDlg, id, buff);
}

/**
 * テキストボックスから文字列を取得
 * @param  HWND		hDlg  ダイアログID
 * @param  unsigned	id    テキストボックスID
 * @return string 取得文字列
*/
string getStrEditBox(HWND hDlg, unsigned id) {
	char buff[SIZE_BUFF];
	GetDlgItemText(hDlg, id, buff, sizeof(buff));
	return (string)buff;
}

/**
 * テキスト・コード変換：SJIS→wstring（Windows API使用）
 * @param  string src SJISテキスト
 * @return string 変換後テキスト
*/
std::wstring __sjis_wstring(std::string src) {
	auto const dest_size = ::MultiByteToWideChar(CP_ACP, 0U, src.data(), -1, nullptr, 0U);
	std::vector<wchar_t> dest(dest_size, L'\0');

	if (::MultiByteToWideChar(CP_ACP, 0U, src.data(), -1, dest.data(), dest.size()) == 0) {
		throw std::system_error{static_cast<int>(::GetLastError()), std::system_category()};
	}
	dest.resize(std::char_traits<wchar_t>::length(dest.data()));
	dest.shrink_to_fit();

	return std::wstring(dest.begin(), dest.end());
}
#define _SW(s)	__sjis_wstring(s)

/**
 * テキスト・コード変換：wstring→SJIS（Windows API使用）
 * @param  wstring src テキスト
 * @return string 変換後テキスト（SJIS）
*/
std::string __wstring_sjis(std::wstring src) {
	auto const dest_size = ::WideCharToMultiByte(CP_ACP, 0U, src.data(), -1, nullptr, 0, nullptr, nullptr);
	std::vector<char> dest(dest_size, '\0');
	if (::WideCharToMultiByte(CP_ACP, 0U, src.data(), -1, dest.data(), dest.size(), nullptr, nullptr) == 0) {
		throw std::system_error{static_cast<int>(::GetLastError()), std::system_category()};
	}
	dest.resize(std::char_traits<char>::length(dest.data()));
	dest.shrink_to_fit();

	return std::string(dest.begin(), dest.end());
}
#define _WS(s)	__wstring_sjis(s)

/**
 * テキスト・コード変換：UTF-8→wstring（Windows API使用）
 * @param  string src UTF-8テキスト
 * @return string 変換後テキスト
*/
wstring __utf8_wstring(std::string src) {
	auto const dest_size = ::MultiByteToWideChar(CP_UTF8, 0U, src.data(), -1, nullptr, 0U);
	std::vector<wchar_t> dest(dest_size, L'\0');
	if (::MultiByteToWideChar(CP_UTF8, 0U, src.data(), -1, dest.data(), dest.size()) == 0) {
		throw std::system_error{static_cast<int>(::GetLastError()), std::system_category()};
	}
	dest.resize(std::char_traits<wchar_t>::length(dest.data()));
	dest.shrink_to_fit();

	return std::wstring(dest.begin(), dest.end());
}
#define _UW(s)	__utf8_wstring(s)

/**
 * テキスト・コード変換：wstring→UTF-8（Windows API使用）
 * @param  wstring src テキスト
 * @return string 変換後テキスト（UTF-8）
*/
std::string __wstring_utf8(std::wstring src) {
	auto const dest_size = ::WideCharToMultiByte(CP_UTF8, 0U, src.data(), -1, nullptr, 0, nullptr, nullptr);
	std::vector<char> dest(dest_size, '\0');

	if (::WideCharToMultiByte(CP_UTF8, 0U, src.data(), -1, dest.data(), dest.size(), nullptr, nullptr) == 0) {
		throw std::system_error{static_cast<int>(::GetLastError()), std::system_category()};
	}
	dest.resize(std::char_traits<char>::length(dest.data()));
	dest.shrink_to_fit();

	return std::string(dest.begin(), dest.end());
}
#define _WU(s)	__wstring_utf8(s)

/**
 * テキスト・コード変換：SJIS→UTF-8（Windows API使用）
 * @param  wstring src SJISテキスト
 * @return string 変換後テキスト（UTF-8）
*/
string sjis_utf8(std::string src) {
	wstring const wide = __sjis_wstring(src);
	return __wstring_utf8(wide);
}

/**
 * テキスト・コード変換：UTF-8→SJIS（Windows API使用）
 * @param  wstring src UTF-8テキスト
 * @return string 変換後テキスト（UTF-8）
*/
string utf8_sjis(std::string src) {
	wstring const wide = __utf8_wstring(src);
	return __wstring_sjis(wide);
}
/**
 * 世界標準時をローカル時間に変換
 * @param  char* gmt   世界標準時（文字列）  例）Fri, 14 Aug 2020 08:46:35
 * @param  char* local ローカル時間を格納    例）2020-08-14 17:46
 * @return なし
*/
time_t gmt2local(char* gmt, char* local) {
	tm t0, t1;
	time_t dt;

	std::istringstream ss((char *)gmt);
	ss >> std::get_time(&t0, "%a, %d %b %Y %H:%M:%S");
	dt = mktime(&t0) - timezone;
	localtime_s(&t1, &dt);
	strftime(local, SIZE_BUFF, "%Y-%m-%d %H:%M", &t1);

	return dt;
}

/**
 * ダイアログを親ウィンドウの中央に配置
 * @param	HWND hDlg		自分のハンドラ
 * @global	HWND hParent	親ウィンドウのハンドラ
 * @return	なし
*/
void CenterWindow(HWND hDlg) {
	int  x, y;
	RECT rc;

	GetWindowRect(hParent, &rc);
	x = rc.left + (rc.right - rc.left) / 2;
	y = rc.top + (rc.bottom - rc.top) / 2;

	SetWindowPos(hDlg, NULL, x, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
}

// オプション読込／保存 ====================================================
/**
 * AppDataのパスを取得
 * @param	char* appname アプリケーション名
 * @return	string パス
 */
string getMyPath(const char* appname) {
	static TCHAR myPath[MAX_PATH] = "";

	if (strlen(myPath) == 0) {
		if (SHGetSpecialFolderPath(NULL, myPath, CSIDL_APPDATA, 0)) {
			TCHAR *ptmp = _tcsrchr(myPath, _T('\\'));
			if (ptmp != NULL) {
				ptmp = _tcsinc(ptmp);
				*ptmp = _T('\0');
			}
			strcat(myPath, _T("Roaming"));
			CreateDirectory((LPCTSTR)myPath, NULL);
			strcat(myPath, _T("\\pahoo.org"));
			CreateDirectory((LPCTSTR)myPath, NULL);
			strcat(myPath, _T("\\"));
			strcat(myPath, _T(appname));
			CreateDirectory((LPCTSTR)myPath, NULL);
			strcat(myPath, _T("\\"));
		} else {
		}
	}
	return (string)myPath;
}

/**
 * パラメータの初期化
 * @param	なし
 * @return	なし
 */
void initParameter(void) {
	hParent_X = 0;
	hParent_Y = 0;
	Query     = "";
}

/**
 * オプションの読み込み
 * @param	なし
 * @return	なし
 */
void loadParameter(void) {
	ptree pt;

	// 初期値設定
	initParameter();

	// XMLファイル読み込み
	try {
		xml_parser::read_xml(getMyPath(APPNAME) + APPNAME + ".xml", pt);

		// XML解釈
		try {
			// 形式チェック
			if (optional<string>str = pt.get_optional<string>("parameter")) {
			} else {
				return;
			}
			// パラメータ読み込み
			for (auto it : pt.get_child("parameter")) {
				string type= it.second.get_optional<string>("<xmlattr>.type").value();
				if (type == "query") {
					Query = utf8_sjis((string)it.second.data());
				} else if (type == "wx") {
					hParent_X = (unsigned)stoi(it.second.data());
				} else if (type == "wy") {
					hParent_Y = (unsigned)stoi(it.second.data());
				}
			}
		// 解釈失敗したら初期値設定
		} catch (xml_parser_error& e) {
			initParameter();
			return;
		}
	// 読み込み失敗したら初期値設定
	} catch (xml_parser_error& e) {
		initParameter();
		return;
	}

	// アプリケーション・ウィンドウの位置（デスクトップ範囲外なら原点移動）
	HWND hDesktop = GetDesktopWindow();
	WINDOWINFO windowInfo;
	windowInfo.cbSize = sizeof(WINDOWINFO);
	GetWindowInfo(hDesktop, &windowInfo);
	if (hParent_X >= (unsigned)windowInfo.rcWindow.right) {
		hParent_X = 0;
	}
	if (hParent_Y >= (unsigned)windowInfo.rcWindow.bottom) {
		hParent_Y = 0;
	}
}

/**
 * オプションの保存
 * @param	なし
 * @return	なし
 */
void saveParameter(void) {
#ifndef CMDAPP
	// アプリケーション・ウィンドウの位置取得
	WINDOWINFO windowInfo;
	windowInfo.cbSize = sizeof(WINDOWINFO);
	GetWindowInfo(hParent, &windowInfo);
	hParent_X = (unsigned)windowInfo.rcWindow.left;
	hParent_Y = (unsigned)windowInfo.rcWindow.top;
	if (hParent_X >= (unsigned)windowInfo.rcWindow.right) {
		hParent_X = 0;
	}
	if (hParent_Y >= (unsigned)windowInfo.rcWindow.bottom) {
		hParent_Y = 0;
	}
#endif

	// XMLファイルへ書き込む
	ptree pt;
	ptree& child1 = pt.add("parameter.param", sjis_utf8(Query));
	child1.add("<xmlattr>.type", "query");
	ptree& child2 = pt.add("parameter.param", (string)to_string(hParent_X));
	child2.add("<xmlattr>.type", "wx");
	ptree& child3 = pt.add("parameter.param", (string)to_string(hParent_Y));
	child3.add("<xmlattr>.type", "wy");

	const int indent = 4;
	write_xml(getMyPath(APPNAME) + APPNAME + ".xml", pt, std::locale(),
		xml_writer_make_settings<std::string>(' ', indent));
}

/**
 * パラメータの削除
 * @param	なし
 * @return	なし
 */
void delParameter(void) {
	remove((getMyPath(APPNAME) + APPNAME + ".xml").c_str());

	// 初期値設定
	initParameter();
}

// バージョン表示ダイアログ =================================================
/**
 * イベントハンドラ：バージョン表示ダイアログ
 * @param	HWND hDlg			ウィンドウ・ハンドラ
 * @paramm	UINT uMsg			メッセージ識別子
 * @param	WPARAM wParam		メッセージの最初のパラメータ
 * @paramL	PARAM lParam		メッセージの2番目のパラメータ
 * @return	INT_PTR CALLBACK	TRUE：メッセージ処理完了／FALSE：未完了
 */
INT_PTR CALLBACK processHelp(HWND hDlg, UINT uMsg,
					WPARAM wParam, LPARAM lParam) {
	switch (uMsg) {
	// ダイアログ初期化
	case WM_INITDIALOG:
		CenterWindow(hDlg);
		setStrEditBox(hDlg, IDC_TEXT_HELP, Version);
		break;

	// ボタン押下
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		// 実行
		case IDC_BUTTON_OK:
			EndDialog(hDlg, 0);
			break;
		default:
			return 1;
		}
		break;
	// プログラム終了
	case WM_CLOSE:
		EndDialog(hDlg, 0);
		break;
	}
	return 0;
}

/**
 * ヘルプ・ダイアログを作成
 * @param  HWND hDlg		親ウィンドウ・ハンドラ
 * @param  DLGPROC handler	イベント・ハンドラ
 * @return なし
*/
void createHelp(HWND hDlg, DLGPROC handler) {
	DialogBox(hInst, MAKEINTRESOURCE(IDD_DIALOG_VER), hDlg, (DLGPROC)handler);
}

// ファイル入出力処理 =======================================================
/**
 * 検索結果をCSVファイルに保存する
 * @param	const char *fname 保存ファイル名
 * @return	なし
*/
void __saveCSV(const char *fname) {
	ofstream outputfile(fname);

	// ラベル
	outputfile << "\"" << "タイトル" << "\",";
	outputfile << "\"" << "メディア" << "\",";
	outputfile << "\"" << "配信日時" << "\",";
	outputfile << "\"" << "記事URL" << "\"" << endl;

	// データ本体
	for (int i = 0; i < SIZE_NEWS; i++) {
		if (News[i] != NULL) {
			outputfile << "\"" << _WS(News[i]->title) << "\",";
			outputfile << "\"" << _WS(News[i]->source) << "\",";
			outputfile << "\"" << News[i]->pubdate.c_str() << "\",";
			outputfile << "\"" << News[i]->link.c_str() << "\"" << endl;
		}
		if (outputfile.bad()) {
			ErrorMessage = "CSVファイル書き込みエラー";
			break;
		}
	}
	outputfile.close();
}

/**
 * 検索結果をCSVファイルに保存する
 * @param	なし
 * @return	なし
*/
void saveCSV(void) {
	static char fname[MAX_PATH + 1];
	strcpy(fname, SAVEFILE);
	OPENFILENAME of;

	// OPENFILENAME構造体のサイズをセット
	memset(&of, 0, sizeof(OPENFILENAME));
	of.lStructSize = sizeof(OPENFILENAME);
	// ダイアログボックスを所有するウィンドウへのハンドル
	of.hwndOwner = hParent;
	of.lpstrFilter = TEXT("CSVファイル(*.csv;*.txt)\0*.csv;*.txt\0すべてのファイル(*.txt)\0*.txt\0\0");
	// ファイル名を格納したバッファのアドレス
	of.lpstrFile = (LPTSTR)fname; 
	// lpstrFileメンバで指定されるバッファのサイズ
	of.nMaxFile = MAX_PATH;
	of.Flags = OFN_OVERWRITEPROMPT;
	// デフォルトの拡張子を格納したバッファのアドレス
	of.lpstrDefExt = TEXT("csv");
	// コモンダイアログの表示
	GetSaveFileName(&of);
	// ファイル保存
	__saveCSV(fname);
}

// Googleニュース検索処理 ===================================================
/**
 * Googleニュース検索URLを生成する（RSS2.0出力）
 * @param	char* query 検索キー
 * @param	char* url   URLを格納
 * @param	size_t sz   urlのサイズ
 * @return	なし
*/
void getURL_GoogleNewsSearch(char* query, char* url, size_t sz) {
	const string google = URL_GOOGLENEWS;

	static char buff1[SIZE_BUFF + 1], buff2[SIZE_BUFF + 1];

	strncpy(buff1, sjis_utf8((string)query).c_str(), SIZE_BUFF);

	CURL *curl = curl_easy_init();
	strncpy(buff2, curl_easy_escape(curl, (const char *)buff1, strlen(buff1)), SIZE_BUFF);

	string ss = google + (string)buff2;
	strncpy(url, ss.c_str(), sz);

	curl_easy_cleanup(curl);
}

size_t callBackFunk(char* ptr, size_t size, size_t nmemb, string* stream) {
	int realsize = size * nmemb;
	stream->append(ptr, realsize);
	return realsize;
}

/**
 * 検索結果を配列に格納する
 * @param	char* query 検索キーワード
 * @param	int   $i    カウンタ
 * @return	int 検索結果の件数
*/
int searchNews(char* query) {
	// 初期化
	for (int i = 0; i < SIZE_NEWS; i++) {
		News[i].reset();
		News[i] = NULL;
	}

	// cURLによる結果取得
	CURL *curl;
	CURLcode res = (CURLcode)0;
	curl = curl_easy_init();
	string chunk;
	char url[SIZE_BUFF + 1];
	getURL_GoogleNewsSearch(query, (char *)url, SIZE_BUFF);

	// cURLによるGoogleニュース検索
	if (curl) {
		curl_easy_setopt(curl, CURLOPT_URL, url);
		curl_easy_setopt(curl, CURLOPT_SSL_VERIFYPEER, 0);
		curl_easy_setopt(curl, CURLOPT_USERAGENT, UserAgent.c_str());
		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, callBackFunk);
		curl_easy_setopt(curl, CURLOPT_WRITEDATA, (string*)&chunk);
		res = curl_easy_perform(curl);
		curl_easy_cleanup(curl);
	}
    if (res != CURLE_OK) {
		ErrorMessage = "Google検索エラー";		// cURLエラー
		return (-1);
	}

	// XML読み込み
	std::stringstream ss;
	ss << chunk;
	ptree pt;
	xml_parser::read_xml(ss, pt);

	// XML解釈
	ptree tree;
	char buff[SIZE_BUFF + 1];
	wstring title2;
	int cnt = -1;
	for (auto it : pt.get_child("rss.channel")) {
		// item以外は読み飛ばし
		if (it.first != "item")		continue;
		cnt++;
		News[cnt] = make_unique<_News>();

		// 見出し
		if (optional<string>title = it.second.get_optional<string>("title")) {
			News[cnt]->title = _UW(title.value());
		}
		// 記事リンク
		if (optional<string>link = it.second.get_optional<string>("link")) {
			News[cnt]->link = link.value();
		}
		// 配信日時
		if (optional<string>pubdate = it.second.get_optional<string>("pubDate")) {
			News[cnt]->ti = gmt2local((char*)pubdate->c_str(), buff);
			News[cnt]->pubdate = (string)buff;
		}
		// 記事概要
		if (optional<string>description = it.second.get_optional<string>("description")) {
			News[cnt]->description = _UW(description.value());
		}
		// メディア
		if (optional<string>source = it.second.get_optional<string>("source")) {
			News[cnt]->source = _UW(source.value());
		}
	}
	chunk.clear();

	return cnt;
}

// 記事ソート用ID
enum {
	SORT_TITLE_ASC,
	SORT_TITLE_DEC,
	SORT_MEDIA_ASC,
	SORT_MEDIA_DEC,
	SORT_PUBDATE_ASC,
	SORT_PUBDATE_DEC,
	SORT_NONE
};

// 記事ソート用ID
enum {
	SORT_ASC,
	SORT_DEC
};

/**
 * 記事ソート用の比較関数：タイトル（昇順）
 * @param	const _stNews& left, right
 * @return	比較結果
*/
bool __cmpTitleAsc(const _stNews& left, const _stNews& right) {
	return wcscmp(left.title, right.title) < 0;
}

/**
 * 記事ソート用の比較関数：タイトル（降順）
 * @param	const _stNews& left, right
 * @return	比較結果
*/
bool __cmpTitleDec(const _stNews& left, const _stNews& right) {
	return wcscmp(left.title, right.title) >= 0;
}

/**
 * 記事ソート用の比較関数：メディア（昇順）
 * @param	const _stNews& left, right
 * @return	比較結果
*/
bool __cmpMediaAsc(const _stNews& left, const _stNews& right) {
	return wcscmp(left.source, right.source) < 0;
}

/**
 * 記事ソート用の比較関数：メディア（降順）
 * @param	const _stNews& left, right
 * @return	比較結果
*/
bool __cmpMediaDec(const _stNews& left, const _stNews& right) {
	return wcscmp(left.source, right.source) >= 0;
}

/**
 * 記事ソート用の比較関数：配信日時（昇順）
 * @param	const _stNews& left, right
 * @return	比較結果
*/
bool __cmpPubDateAsc(const _stNews& left, const _stNews& right) {
	return left.ti < right.ti;
}

/**
 * 記事ソート用の比較関数：配信日時（降順）
 * @param	const _stNews& left, right
 * @return	比較結果
*/
bool __cmpPubDateDec(const _stNews& left, const _stNews& right) {
	return left.ti >= right.ti;
}

/**
 * ソート用変数に代入
 * @param	const _stNews& left, right
 * @return	比較結果
*/
_stNews __push_stNews(unique_ptr<_News> &ptr) {
	_stNews s;
	s.title		= (wchar_t*)ptr->title.c_str();
	s.source	= (wchar_t*)ptr->source.c_str();
	s.pubdate	= (char*)ptr->pubdate.c_str();
	s.ti		= (time_t)ptr->ti;
	s.link		= (char*)ptr->link.c_str();
	return s;
}

/**
 * ニュース記事のソート
 * @param	int c  ソート条件
 * @return	なし
*/
void sortNews(int c) {
	struct {
		int id;
		bool (*fn)(const _stNews& left, const _stNews& right);
} table[] = {
	{ SORT_TITLE_ASC,	__cmpTitleAsc },
	{ SORT_TITLE_DEC,	__cmpTitleDec },
	{ SORT_MEDIA_ASC,	__cmpMediaAsc },
	{ SORT_MEDIA_DEC,	__cmpMediaDec },
	{ SORT_PUBDATE_ASC,	__cmpPubDateAsc },
	{ SORT_PUBDATE_DEC,	__cmpPubDateDec }
};
	int i;
	bool (*fn)(const _stNews& left, const _stNews& right) = NULL;

	// ソート用配列の初期化
	Vnews.clear();
	Vnews.shrink_to_fit();

	// ニュース記事をソート用配列へ
	for (i = 0; i < SIZE_NEWS; i++) {
		if (News[i] != NULL) {
			Vnews.push_back(__push_stNews(News[i]));
		}
	}

	// ソート用関数の選択
	for (i = 0; i < (int)(sizeof(table) / sizeof(*table)); i++) {
		if (c == table[i].id) {
			fn = table[i].fn;
			break;
		}
	}

	// ソート実行
	if (fn != NULL) {
		stable_sort(Vnews.begin(), Vnews.end(), fn);
	}
}

// リストビューの列
enum {
	COL_TITLE,
	COL_SOURCE,
	COL_PUBDATE,
	COL_LINK
};

/**
 * ニュース一覧のフレーム作成
 * @param	HWND hDlg  ウィンドウハンドル
 * @return	なし
*/
void makeListViewFrame(HWND hWnd) {
	LVCOLUMNA lvcol;
	lvcol.mask = LVCF_TEXT | LVCF_SUBITEM | LVCF_WIDTH | LVCF_FMT;
	lvcol.fmt = LVCFMT_LEFT;

	lvcol.cx = 500;
	lvcol.pszText = (char *)"タイトル";
	SendMessage(hWnd, LVM_INSERTCOLUMNA, COL_TITLE, (WPARAM)&lvcol);
	lvcol.cx = 150;
	lvcol.pszText = (char *)"メディア";
	SendMessage(hWnd, LVM_INSERTCOLUMNA, COL_SOURCE, (WPARAM)&lvcol);
	lvcol.cx = 150;
	lvcol.pszText = (char *)"配信日時";
	SendMessage(hWnd, LVM_INSERTCOLUMNA, COL_PUBDATE, (WPARAM)&lvcol);
	lvcol.cx = 0;
	lvcol.pszText = (char *)"URL";
	SendMessage(hWnd, LVM_INSERTCOLUMNA, COL_LINK, (WPARAM)&lvcol);

	// 罫線表示
	DWORD dwStyle = ListView_GetExtendedListViewStyle(hWnd);
	dwStyle = dwStyle | LVS_EX_GRIDLINES | LVS_EX_ONECLICKACTIVATE;
	ListView_SetExtendedListViewStyle(hWnd, dwStyle);
}

/**
 * ニュース一覧作成
 * @param	HWND hDlg  ウィンドウハンドル
 * @return	なし
*/
void makeListView(HWND hWnd) {
	LVITEMA item;

	// 初期化
	for (int i = 0; i < SIZE_NEWS; i++) {
		item.iItem = i;
		SendMessage(hWnd, LVM_DELETEITEM, 0,(WPARAM)&item);
	}

	// データ行
	for (int i = 0; i < SIZE_NEWS; i++) {
		if (News[i] == NULL)	break;
		// タイトル
		item.mask = LVIF_TEXT;
		item.iItem = i;
		item.iSubItem = COL_TITLE;
		item.pszText = (LPSTR)_WS(Vnews[i].title).substr(0, MAX_LISTVIEWITEM).c_str();
		SendMessage(hWnd, LVM_INSERTITEMA, 0,(WPARAM)&item);
		// メディア
		item.iSubItem = COL_SOURCE;
		item.pszText = (LPSTR)_WS(Vnews[i].source).substr(0, MAX_LISTVIEWITEM).c_str();
		SendMessage(hWnd, LVM_SETITEMA, 0,(WPARAM)&item);
		// 配信日時
		item.iSubItem = COL_PUBDATE;
		item.pszText = (LPSTR)Vnews[i].pubdate;
		SendMessage(hWnd, LVM_SETITEMA, 0,(WPARAM)&item);
		// リンク
		item.iSubItem = COL_LINK;
		item.pszText = (LPSTR)Vnews[i].link;
		SendMessage(hWnd, LVM_SETITEMA, 0,(WPARAM)&item);
	}
}

// メインウィンドウ ==========================================================
/**
 * イベントハンドラ：メインウィンドウ
 * @param	HWND hDlg			親ウィンドウ・ハンドラ
 * @paramm	UINT uMsg			メッセージ識別子
 * @param	WPARAM wParam		メッセージの最初のパラメータ
 * @paramL	PARAM lParam		メッセージの2番目のパラメータ
 * @return	INT_PTR CALLBACK	TRUE：メッセージ処理完了／FALSE：未完了
*/
INT_PTR CALLBACK processMain(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	HICON hIcon;
	char *str;
	LVITEM item;
	LV_HITTESTINFO lvinfo;
	NM_LISTVIEW *pNMLV;
	TCHAR buff[SIZE_BUFF + 1];
	static int subsort[100];

	switch(uMsg){
	// ダイアログ初期化
	case WM_INITDIALOG:
		hParent = hDlg;
		hIcon = (HICON)LoadImage(hInst, MAKEINTRESOURCE(IDI_ICON), IMAGE_ICON, 16, 16, 0);
		SendMessage(hParent, WM_SETICON, ICON_SMALL, (LPARAM) hIcon);
		ErrorMessage = "";
		// オプション読み込み
		loadParameter();
		setStrEditBox(hDlg, IDC_EDIT_QUERY, Query);
		// アプリケーション・ウィンドウ移動
		SetWindowPos(hParent, NULL, hParent_X, hParent_Y, 0, 0, (SWP_NOSIZE | SWP_NOZORDER | SWP_NOOWNERZORDER));
		makeListViewFrame(GetDlgItem(hDlg, IDC_LISTVIEW_NEWS));
		break;

	// ボタン押下
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		// 実行
		case IDM_EXEC:
		case IDC_BUTTON_SEARCH:
			ErrorMessage = "";
			// カーソルを砂時計に
			SetCursor(LoadCursor(NULL, IDC_WAIT));
			Query = getStrEditBox(hDlg, IDC_EDIT_QUERY);
			// Googleニュース検索
			searchNews((char *)Query.c_str());
			sortNews(SORT_NONE);
			// 一覧表示
			makeListView(GetDlgItem(hDlg, IDC_LISTVIEW_NEWS));
			setStrEditBox(hDlg, IDC_TEXT_ERROR, ErrorMessage);
			break;
		// 保存
		case IDC_BUTTON_SAVE:
		case IDM_SAVE:
			saveCSV();
			break;
		// 設定クリア＋アプリ終了
		case IDM_CLEAR_PARAMETER:
			delParameter();
			EndDialog(hParent, 0);
			return 0;
			break;
		// ヘルプ
		case IDM_HELP:
			ShellExecute(hParent, _T("open"), _T(HELPFILE), NULL, NULL, SW_RESTORE);
			break;
		// バージョン表示
		case IDM_VERSION:
			createHelp(hParent, processHelp);
			break;
		// 解説サイト
		case IDM_PAHOO:
			ShellExecute(NULL, _T("open"), _T(REFERENCE), NULL, NULL, SW_RESTORE);
			break;
		// コピー
		case IDM_COPY:
			setClipboardData(getStrEditBox(hParent, IDC_EDIT_QUERY));
			break;
		// 貼り付け
		case IDM_PASTE:
			str = getClipboardData();
			if (str != NULL) {
				setStrEditBox(hParent, IDC_EDIT_QUERY, str);
			}
			break;
		// 切り取り
		case IDM_DELETE:
			setStrEditBox(hParent, IDC_EDIT_QUERY, "");
			break;
		// プログラム終了
		case IDM_QUIT:
			// オプション保存
			saveParameter();
			EndDialog(hParent, 0);
			return 0;
		default:
			return 1;
	}
	break;

	// 通知
	case WM_NOTIFY:
		switch(((LPNMHDR)lParam)->idFrom) {
		case IDC_LISTVIEW_NEWS:
			switch (((LPNMLISTVIEW)lParam)->hdr.code) {
			// 一覧のラベルがクリック
			case LVN_COLUMNCLICK:
				pNMLV = (NM_LISTVIEW *)lParam;
				if (subsort[pNMLV->iSubItem] == SORT_ASC) {
					subsort[pNMLV->iSubItem] = SORT_DEC;
				} else {
					subsort[pNMLV->iSubItem] = SORT_ASC;
				}
				// ニュース記事の並べ替え
				sortNews(pNMLV->iSubItem * 2 + subsort[pNMLV->iSubItem]);
				// 一覧表示
				makeListView(GetDlgItem(hDlg, IDC_LISTVIEW_NEWS));
				break;
			// ニュース一覧の1行を選択
			case LVN_ITEMCHANGED:
			// ニュース一覧の1行をダブルクリック
			// case NM_DBLCLK:
				GetCursorPos((LPPOINT)&lvinfo.pt);
				ScreenToClient(((LPNMLISTVIEW)lParam)->hdr.hwndFrom, &lvinfo.pt);
				ListView_HitTest(((LPNMLISTVIEW)lParam)->hdr.hwndFrom, &lvinfo);
				if ((lvinfo.flags & LVHT_ONITEM) != 0) {
					item.mask = TVIF_HANDLE | TVIF_TEXT;
					item.iItem = lvinfo.iItem;
					item.iSubItem = COL_LINK;
					item.pszText = buff;
					item.cchTextMax = SIZE_BUFF;
					ListView_GetItem(((LPNMLISTVIEW)lParam)->hdr.hwndFrom, &item);
					// ブラウザ起動
					ShellExecute(hParent, _T("open"), _T(buff), NULL, NULL, SW_RESTORE);
				}
				break;
			default:
				break;
		}
		break;
	default:
		break;
	}
	break;

	// プログラム終了
	case WM_CLOSE:
		// オプション保存
		saveParameter();
		EndDialog(hParent, 0);
		return 0;
	}
	return 0;
}

// メイン・プログラム =======================================================
/**
 * Windowsメインプログラム
 * @param	HINSTANCE hInstance			インスタンスハンドル
 * @paramm	HINSTANCE hPrevInstance		未使用(常にNULL)：Win16時代の名残
 * @param	LPSTR lpCmdLine				コマンドライン引数
 * @paramL	int nShowCmd				ウィンドウの表示方法
 * @return	int リターンコード
*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd) {
	LoadLibrary("RICHED20.DLL");

	// UserAgent生成
	static OSVERSIONINFOEX os;
	GetVersion2(&os);
	UserAgent = (string)"Mozilla/5.0 (" + APPNAME + "/"
		+ APPVERSION + "/" + MAKER
		+ ", Windows NT " + to_string(os.dwMajorVersion) + "."
		+ to_string(os.dwMinorVersion) + ")";

	hInst = hInstance;
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, (DLGPROC)processMain);
	return 0;
}

/*
** バージョンアップ履歴 =====================================================
 *
 * @version 1.5.10 2026/02/14 使用ライブラリ更新
 * @version 1.5.9  2025/10/18 使用ライブラリ更新
 * @version 1.5.8  2025/07/05 使用ライブラリ更新
 * @version 1.5.7  2025/03/01 使用ライブラリ更新
 * @version 1.5.6  2024/11/16 使用ライブラリ更新
 * @version 1.5.5  2024/07/14 使用ライブラリ更新
 * @version 1.5.4  2024/03/06 使用ライブラリ更新
 * @version 1.5.3  2023/10/14 使用ライブラリ更新
 * @version 1.5.2  2023/06/10 使用ライブラリ更新
 * @version 1.5.1  2023/03/05 使用ライブラリ更新
 * @version 1.5.0  2022/11/05 設定クリア機能，使用ライブラリ更新
 * @version 1.4    2022/07/23 ウィンドウ位置・検索キー保存，使用ライブラリ更新
 * @version 1.3    2022/04/29 UserAgent追加，libcurl・OpenSSLを最新版に更新
 * @version 1.2    2020/09/05 データ構造をstring/wstringに変更
 * @version 1.1    2020/08/29 iconv, Libxml2をBoost C++ライブラリで置き換え
 * @version 1.0    2020/08/15 初版
*/
